/* tslint:disable:no-any */
import {Observable} from 'rxjs/Observable';
import {HttpClient, HttpResponse} from '@angular/common/http';
import {Epic} from 'redux-observable';
import {catchError, map, switchMap} from 'rxjs/operators';

export interface ${Interface_name}State {
  zustand: string;
  fehler: string;
  ${Interface_attribute}: ${Interface_type};
}

export const INIT_STATE_${Init_state_const_name}: ${Interface_name}State = {
  zustand: '',
  fehler: '',
  ${Interface_attribute}: {}
};

export const ${Init_state_const_name}_ANFORDERUNG = '${Init_state_const_name}_ANFORDERUNG';
export const ${Init_state_const_name}_ERFOLG = '${Init_state_const_name}_ERFOLG';
export const ${Init_state_const_name}_FEHLER = '${Init_state_const_name}_FEHLER';

export function ${Reducer_name}(
  state: ${Interface_name}State = INIT_STATE_${Init_state_const_name},
  action: Action<any>): ${Interface_name}State {

  switch (action.type) {
    case ${Init_state_const_name}_ANFORDERUNG : {
      return {
        ...state,
        zustand: '${State_Anforderung}',
        fehler: '',
        ${Interface_attribute}: action.payload.${Payload_attribute}
      };
    }
    case ${Init_state_const_name}_ERFOLG : {
      return {
        ...state,
        zustand: '${State_Erfolg}',
        fehler: '',
        ${Interface_attribute}: action.payload.${Payload_attribute}
      };
    }
    case ${Init_state_const_name}_FEHLER :
      return {
        ...state,
        zustand: 'FEHLER',
        fehler: action.payload,
        ${Interface_attribute}: {}
      };
    default:
      return state;
  }
}

export function ${Epic_name}Epic(http: HttpClient, url: TemplateUrl): Epic<Action<any>, {}> {
  const FEHLERAUSGABE = '${Error_message}';

  return action$ => action$
    .ofType(${Init_state_const_name}_ANFORDERUNG)
    .pipe(
      switchMap(action => {
        const payload: ${Interface_type} = action.payload.${Payload_attribute};

        return senden(http, url, payload)
          .pipe(
            map(() => {
              return createAction(${Init_state_const_name}_ERFOLG, {payload});
            }),
            catchError(() => {
              return Observable.of(createAction(${Init_state_const_name}_FEHLER, FEHLERAUSGABE));
            })
          );
      })
    );
}

function senden(http: HttpClient, url: TemplateUrl, payload: ${Interface_type}): Observable<HttpResponse<string>> {
  return http.post(url(), payload, {observe: 'response', responseType: 'text'});
}
