import {Injectable} from '@angular/core';
import {Observable} from 'rxjs';
import {IEvent} from '../../../shared/models/event.model';
import {dispatch, select} from '@angular-redux/store';
import {createAction} from '../../../shared/redux/actions';
import {LOAD_TIMELINE_REQUEST} from './timeline.redux';
import {AppState} from '../../../shared/redux';

@Injectable()
export class TimelineStateService {

  @select((state: AppState) => state.timeline.events)
  public events$: Observable<IEvent[]>;

  private processId: string;

  @dispatch()
  public loadTimeline(processId: string) {
    this.processId = processId;

    return createAction(LOAD_TIMELINE_REQUEST, processId);
  }
}
