import {async, ComponentFixture, inject, TestBed} from '@angular/core/testing';
import {FormsModule, ReactiveFormsModule} from '@angular/forms';
import {TimelineComponent} from './timeline.component';
import {Component, CUSTOM_ELEMENTS_SCHEMA, ViewChild} from '@angular/core';
import {TimelineStateService} from '../../../core/services/timeline/timeline.service';
import {HttpClientModule} from '@angular/common/http';
import {of} from 'rxjs';
import {TIMELINE} from '../../../core/mocks/timeline.mock';

describe('TimelineComponent', () => {

  describe('ComponentUnderTestComponent', () => {
    let testHostComponent: TestHostComponent;
    let testHostFixture: ComponentFixture<TestHostComponent>;

    beforeEach(async(() => {
      TestBed.configureTestingModule({
        imports: [
          ReactiveFormsModule,
          FormsModule,
          HttpClientModule
        ],
        providers: [
          {
            provide: TimelineStateService,
            useValue: {
              ...jasmine.createSpyObj('TimelineStateService', ['loadTimeline', 'reloadTimeline']),
              timeline$: of(TIMELINE)
            }
          }
        ],
        schemas: [CUSTOM_ELEMENTS_SCHEMA],
        declarations: [TimelineComponent, TestHostComponent]
      })
        .compileComponents();
    }));

    beforeEach(() => {
      testHostFixture = TestBed.createComponent(TestHostComponent);
      testHostComponent = testHostFixture.componentInstance;
      testHostFixture.detectChanges();
    });

    it('Sollte beim Initialisieren die Timeline laden',
      inject([TimelineStateService], (timelineStateService: TimelineStateService) => {
      const spy = <jasmine.Spy> timelineStateService.loadTimeline;
      expect(spy).toHaveBeenCalledWith('1');
    }));

    @Component({
      selector: 'host-component',
      template: '<timeline processId="1"></timeline>'
    })
    class TestHostComponent {
      @ViewChild(TimelineComponent)
      public componentUnderTestComponent: TimelineComponent;
    }
  });
});
