import {NgModule} from '@angular/core';
import {TimelineComponent} from './components/timeline.component';
import {CommonModule} from '@angular/common';
import {MatCardModule, MatIconModule, MatInputModule, MatListModule} from '@angular/material';
import {TimelineStateService} from '../../core/services/timeline/timeline.service';
import {CovalentMarkdownModule} from '@covalent/markdown';
import {EpicProvider} from '../../shared/redux/provider';
import {HttpClient} from '@angular/common/http';
import {loadTimelineEpic} from '../../core/services/timeline/timeline.redux';
import {einstiegspunkte} from '../../shared/einstiegspunkte';

@NgModule({
  imports: [CommonModule, MatCardModule, MatIconModule, MatListModule, MatInputModule, CovalentMarkdownModule],
  providers: [
    einstiegspunkte,
    TimelineStateService,
    EpicProvider(loadTimelineEpic, [HttpClient, 'timeline.laden'])
  ],
  declarations: [
    TimelineComponent
  ],
  exports: [TimelineComponent]
})
export class TimelineModule {

}
