import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';
import {CovalentCommonModule, CovalentFileModule} from '@covalent/core';
import {FlexLayoutModule} from '@angular/flex-layout';
import {
    MatAutocompleteModule,
    MatButtonModule,
    MatCardModule,
    MatCheckboxModule,
    MatDatepickerModule,
    MatDialogModule,
    MatFormFieldModule,
    MatIconModule,
    MatInputModule,
    MatListModule,
    MatMenuModule,
    MatNativeDateModule,
    MatProgressBarModule,
    MatSelectModule,
    MatSidenavModule,
    MatSnackBarModule, MatStepperModule,
    MatTableModule,
    MatTabsModule,
    MatToolbarModule,
    MatTooltipModule
} from '@angular/material';

import {RouterModule} from '@angular/router';
import {FormsModule, ReactiveFormsModule} from '@angular/forms';

@NgModule({
  declarations: [
  ],

  exports:
    [
      FlexLayoutModule,

      // Covalent Modules
      CovalentCommonModule,
      CovalentCommonModule,
      CovalentFileModule,

      // Material Modules
      MatStepperModule,
      MatProgressBarModule,
      MatSidenavModule,
      MatToolbarModule,
      MatInputModule,
      MatCardModule,
      MatButtonModule,
      MatIconModule,
      MatListModule,
      MatDialogModule,
      MatTabsModule,
      MatCheckboxModule,
      MatDatepickerModule,
      MatNativeDateModule,
      MatSelectModule,
      MatTooltipModule,
      MatMenuModule,
      MatAutocompleteModule,
      MatSnackBarModule,
      MatTableModule,
    ],
  imports: [
    FormsModule,
    ReactiveFormsModule,
    CommonModule,
    FlexLayoutModule,
    RouterModule,

    // Material Modules
    MatProgressBarModule,
    MatAutocompleteModule,
    MatStepperModule,
    MatFormFieldModule,
    MatInputModule,
    MatSidenavModule,
    MatToolbarModule,
    MatButtonModule,
    MatListModule,
    MatCardModule,
    MatIconModule
  ]
})
export class SharedModule {
}
