/* tslint:disable:no-any no-conditional-assignment */
import {TemplateUrl} from './templateurl';

export const url2template: Function = (url: string): TemplateUrl => {
  const regEx: RegExp = /{([^}]+)?}/;
  const regExArray: RegExp = /\[([^\]]+)?\]/;

  return (data: any) => {
    let parsedUrl: string = url;
    let match: any;
    while (match = regEx.exec(parsedUrl)) {
      parsedUrl = parsedUrl.replace(match[0], encodeURIComponent(data[match[1]]));
    }
    while (match = regExArray.exec(parsedUrl)) {
      parsedUrl = parsedUrl.replace(match[0], data[match[1]]);
    }

    return parsedUrl;
  };
};
